// Toss Sound
datablock AudioProfile(AmmoThrow)
{
   filename    = "./AmmoThrow.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(AmmoEquip)
{
   filename    = "./AmmoEquip.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(Ammo)
{
   filename    = "./Ammo.wav";
   description = AudioClosest3d;
   preload = true;
};
// Item Data
datablock ItemData(AmmoBoxPickupItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // AmmoBox Item Properties
	shapeFile = "./AmmoBox.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 1;
	emap = true;

	//gui stuff
	uiName = "Ammo Box (Item)";
	iconName = "./Icon_AmmoBox";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = AmmoBoxImage;
	canDrop = true;
};

datablock ItemData(AmmoBoxDropItem : AmmoBoxPickupItem)
{
	uiName = "Ammo Box (PickUp)";
};

// AmmoBox Image
datablock ShapeBaseImageData(AmmoBoxImage)
{
   // AmmoBox Item properties
   shapeFile = "./AmmoBox.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this AmmoBox doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the AmmoBoxImage namespace as a parent, AmmoBoxImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = AmmoBoxPickupItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   
   minShotTime = 3000;

   doColorShift = false;
   colorShiftColor = AmmoBoxPickupItem.colorShiftColor; 

	// Main gun functionality
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "Ready";
	StateSequence[0]					= "use";
	StateSound[0]						= "AmmoEquip";
	StateScript[0]						= "onEquiped";
	
	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Toss";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Toss";
	stateTransitionOnTimeout[2]     	= "Ready";
	stateTimeoutValue[2]            	= 0.1;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
};

function AmmoBoxImage::onFire(%this, %obj, %slot)
{
	%value = %obj.lastFireTime + 3000 > getSimTime();
	if(!%value)
	{
		serverPlay3D(AmmoThrow,%obj.getPosition());
		%obj.playThread(2, activate2);
		dropDatAmmo(%obj.Client);
		%obj.lastFireTime = getSimTime();
	}
}
// This is the function we call when the player is freaking droppin a box O' Ammo
// Designed by IPQ
function dropDatAmmo(%client)
{
	deleteAmmoBox(%client);
    %item = new Item()
    {
    	datablock = AmmoBoxDropItem;
		minigame = %client.minigame;
    };
    %item.setTransform(VectorAdd(setWord(%client.player.getTransform(), 2, getWord(%client.player.getTransform(), 2) + 2), %client.player.getEyeVector()));
    %item.setVelocity(VectorScale(%client.player.getEyeVector(), 10));
	%client.currAmmoBox = %item;
    MissionCleanup.add(%item);
	%client.player.schedule(30000, deleteAmmoBox, %client);
}
package ammoBoxPackage
{
function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
{
	if(%col.dataBlock $= "AmmoBoxDropItem" && %col.canPickup && %obj.getDamagePercent() < 1.0 && minigameCanUse(%obj.client, %col))
	{
	%obj.client.quantity["AmmoPistol"] += 9;
	if(%obj.client.quantity["AmmoPistol"] > 3*9)
	{
	%obj.client.quantity["AmmoPistol"] = 3*30;
	}
	%obj.client.quantity["AmmoBean"] += 1;
	if(%obj.client.quantity["AmmoBean"] > 4*1)
	{
	%obj.client.quantity["AmmoBean"] = 4*1;
	}
	%obj.client.quantity["AmmoMedium"] += 30;
	if(%obj.client.quantity["AmmoMedium"] > 3*30)
	{
	%obj.client.quantity["AmmoMedium"] = 3*30;
	}
	%obj.client.quantity["AmmoLight"] += 30;
	if(%obj.client.quantity["AmmoLight"] > 4*30)
	{
	%obj.client.quantity["AmmoLight"] = 4*30;
	}
	%obj.client.quantity["AmmoHeavy"] += 20;
	if(%obj.client.quantity["AmmoHeavy"] > 3*20)
	{
	%obj.client.quantity["AmmoHeavy"] = 3*20;
	}
	%obj.client.quantity["AmmoSniper"] += 10;
	if(%obj.client.quantity["AmmoSniper"] > 2*10)
	{
	%obj.client.quantity["AmmoSniper"] = 2*10;
	}
	%obj.client.quantity["AmmoMG"] += 50;
	if(%obj.client.quantity["AmmoMG"] > 2*100)
	{
	%obj.client.quantity["AmmoMG"] = 2*100;
	}
		%obj.client.quantity["AmmoShotgun"] += 8;
	if(%obj.client.quantity["AmmoShotgun"] > 3*8)
	{
	%obj.client.quantity["AmmoShotgun"] = 3*8;
	}
		serverPlay3D(Ammo,%obj.getPosition());
		%this.onPickup(%obj, %player);
		
		// Pickup Schtuffz
		if(isObject(%col.spawnbrick))
		{
			%col.fadeOut();
			%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
		}
		else
		{
			%col.fadeOut();
			%col.schedule(1000, "fadeIn");
		}
		return;
	}
	Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
}

function gameConnection::onDeath(%client,%obj,%killer,%type,%location)
{
	Parent::onDeath(%client,%obj,%killer,%type,%location);
	deleteAmmoBox(%client);
}

function GameConnection::OnClientLeaveGame(%this)
{
	deleteAmmoBox(%this);
	Parent::OnClientLeaveGame(%this);
}

function MinigameSO::reset(%this,%client)
{
	Parent::reset(%this,%client);
	for(%i=0;%i<%this.numMembers;%i++)
	{
		%cl=%this.member[%i];
		//Check for hacky dedicated minigame mods or AIConnections
		if(isObject(%cl) && %cl.getClassName() $= "GameConnection")
		{
			deleteAmmoBox(%cl);
		}
	}
}
};
activatePackage(ammoBoxPackage);

function AmmoBoxImage::onMount(%this, %obj, %slot)
{
	%obj.playThread(0, "armReadyLeft");
	parent::onMount(%this, %obj, %slot);
}

function AmmoBoxImage::onUnMount(%this, %obj, %slot)
{
	%obj.playThread(0, "root");
	parent::onUnMount(%this, %obj, %slot);
}

function deleteAmmoBox(%client)
{
	if(isObject(%client.currAmmoBox) == 1)
	{
		%item = %client.currAmmoBox;
		%item.delete();
	}
}